// Cegid Peoplenet ClickOnce launcher
// background.js
// version 1.4
// Cegid Spain S.A.

// Analyze for ClickOnce requests
chrome.webRequest.onBeforeRequest.addListener(function (details) {
    var extension = '.application';
    if (details.url.indexOf(extension) != -1) {
        // Analyze indeep the request

        var parse_url = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;
        // ['url', 'scheme', 'slash', 'host', 'port', 'path', 'query', 'hash'];
        var result = parse_url.exec(details.url);
        // Search at the end of the the url's path
        if (result[5].length > extension.length && result[5].indexOf(extension, result[5].length - extension.length) > 0) {
            // Send message to native code for launching the ClickOnce 
            chrome.runtime.sendNativeMessage('meta4.clickonce.clickoncehelper',
		      { url: details.url });

            // Redirect to do nothing
            url = 'javascript:void()';
            return { redirectUrl: url };
        }
    }
}, { urls: ['http://*/*', 'https://*/*'] }, ['blocking']);



// Show the one step page in installation
chrome.runtime.onInstalled.addListener(function(details) {
	if (details.reason == 'install' || details.reason == 'update'){
		url = chrome.extension.getURL('nativeinstall.html');
		chrome.tabs.create({'url': url});
	}
});
